/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "math.h"

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
     int steps;
     float ali;
     float coh;
     float sep;
     int frnd;
     float X[20] = {126, 78, 96, 119, 114, 123, 94, 10, 82, 80, 86, 119, 64, 77, 94, 15, 16, 20, 28, 98};
     float Y[20] = {53, 37, 34, 56, 17, 55, 45, 38, 32, 42, 38, 6, 58, 7, 33, 18, 52, 63, 59, 47};
     float Vx[20] = {2, -2, 2, -2, 1, 2, 1, 2, 1, -1, -2, 0, -1, 2, 1, -1, -2, 2, 1, -2};
     float Vy[20] = {-2, 1, 2, -2, -1, 1, 2, -1, 0, -2, -1, 1, 2, 1, 2, 1, -2, 2, -2, 2};
     float ClsX;
     float ClsY;
     float spd;
     float min;
     float max;
     float VxAvrg;
     float VyAvrg;
     float Sep;
     int boid;
     int otherboid;
     float Xvrg;
     float Yvrg;
     steps = 0;
     sep = 0.1;
     Sep = 0.85;
     ali = 0.05;
     coh = 0.01;
     frnd = 0;
     min = 1;
     max = 2;
     while (steps<1000){
          Bdisp_AllClr_VRAM();
          Sleep(100);
          steps += 1;
          /*boid update loop*/
          for (boid = 0; boid <20; boid++){
               frnd = 0;
               spd = sqrt(Vx[boid]*Vx[boid]+Vy[boid]*Vy[boid]);
               if (spd>max){
                    Vx[boid] = (Vx[boid]/spd)*max;
                    Vy[boid] = (Vy[boid]/spd)*max;
               }
               if (spd<min){
                    Vx[boid] = (Vx[boid]/spd)*min;
                    Vy[boid] = (Vy[boid]/spd)*min;
               }
               if (X[boid]<15){
                    Vx[boid] += Sep;
               }
               if (X[boid]>112){
                    Vx[boid] -= Sep;
               }
               if (Y[boid]<15){
                    Vy[boid] += Sep;
               }
               if (Y[boid]>48){
                    Vy[boid] -= Sep;
               }
               ClsX = 0;
               ClsY = 0;
               VxAvrg = 0;
               VyAvrg = 0;
               Xvrg = 0;
               Yvrg = 0;
               frnd = 0;
               X[boid] = Vx[boid]+X[boid];
               Y[boid] = Vy[boid]+Y[boid];
               if (X[boid]<1){
                    X[boid] = 127;
               }
               if (X[boid]>127){
                    X[boid] = 1;
                    }
               if (Y[boid]>63){
                    Y[boid] = 1;
               }
               if (Y[boid]<1){
                    Y[boid] = 63;
               }
               for (otherboid = 0; otherboid <20; otherboid++){
                    if ((X[otherboid]>X[boid]-5)&(X[otherboid]<X[boid]+5)&(Y[otherboid]>Y[boid]-5)&(Y[otherboid]<Y[boid]+5)){
                         ClsX += X[boid] - X[otherboid];
                         ClsY += Y[boid] - Y[otherboid];
                    }
                    if ((X[otherboid]>X[boid]-12)&(X[otherboid]<X[boid]+12)&(Y[otherboid]>Y[boid]-12)&(Y[otherboid]<Y[boid]+12)){
                         VxAvrg += Vx[otherboid];
                         VyAvrg += Vy[otherboid];
                         Xvrg += X[otherboid];
                         Yvrg += Y[otherboid];
                         frnd += 1;
                    }
               }
               if (frnd> 0){
                    VxAvrg = VxAvrg/frnd;
                    VyAvrg = VyAvrg/frnd;
                    Xvrg = Xvrg/frnd;
                    Yvrg = Yvrg/frnd;
               }
               Vx[boid] += (Xvrg-X[boid])*coh;
               Vy[boid] += (Xvrg-X[boid])*coh;
               Vx[boid] += (VxAvrg-Vx[boid])*ali;
               Vy[boid] += (VyAvrg-Vy[boid])*ali;
               Vx[boid] += ClsX*sep;
               Vy[boid] += ClsY*sep;
               Bdisp_DrawLineVRAM(X[boid], Y[boid], X[boid]+Vx[boid], Y[boid]+Vy[boid]);
               Bdisp_PutDisp_DD();
          }
          Bdisp_PutDisp_DD();
     }
     return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

